from schedcat.generator.tasks import uniform_int, uniform, exponential, multimodal, uniform_choice
from schedcat.model.LLCLayout import *

def bypass_scheme(cores):
    AB = area(0, 4)
    C = area(16, 16)
    return scheme([AB for i in range(cores)], [AB for i in range(cores)], C, 16, 16)

def default_scheme(cores):
    AB = area(4, 4)
    C = area(8, 16)
    return scheme([AB for i in range(cores)], [AB for i in range(cores)], C, 16, 16)
    
def default_share_scheme(cores):
    AB = area(8, 4)
    C = area(8, 16)
    return scheme([AB for i in range(cores)], [AB for i in range(cores)], C, 16, 16)
    
def default_share_iso_scheme(cores):
    AB = area(8, 4)
    C = area(2, 16)
    return scheme([AB for i in range(cores)], [AB for i in range(cores)], C, 16, 16)

def pedf_scheme(cores):
    A = area(0, 0)
    B = area(16, 4)
    C = area(0, 0)
    return scheme([A for i in range(cores)], [B for i in range(cores)], C, 16, 16)
    
def uni_scheme(cores):
    A = area(0, 0)
    B = area(16, 16)
    C = area(0, 0)
    return scheme([A for i in range(cores)], [B for i in range(cores)], C, 16, 16)
    
def c_iso_scheme(cores):
    AB = area(4, 4)
    C = area(8, 4)
    return scheme([AB for i in range(cores)], [AB for i in range(cores)], C, 16, 16)

#50-70 to #80-100
#20-40 to #30-60
def AVG_PERCENT(bkgrnd_load, level):
    min1, min2, max1, max2 = (0, 0, 0, 0)
    if level is 'A' or level is 'B':
        min1, max1, min2, max2 = {0.5, 0.7, 0.8, 1.0}
    elif level is 'C':
        min1, max1, min2, max2 = {0.2, 0.4, 0.3, 0.6}
    else:
        print "\n error in distributions, line 30 \n"
    
    bary = min(1.0, bkgrnd_load/4.0)
    
    tskmin = min1 + bary*(min2-min1)
    tskmax = max1 + bary*(max2-max1)
    
    return uniform(tskmin, tskmax)()

unmanwt = uniform(1.0, 1.3)
loadedinfAB = uniform(1.2, 1.5) 
loadedinfC = uniform(1.2, 1.5) 

dlight = uniform(0.1, 0.3)
dmoder = uniform(0.35, 0.45)
dheavy = uniform(0.5, 0.7)

#     'all' : {'A' : uniform(0.1, 0.7), 'B' : uniform(0.1, 0.7), 'C' : uniform(0.1, 0.7)},
NAMED_UTIL_DISTS = {
#     'heavy-light-light'    : {'A' : dheavy, 'B' : dlight, 'C' : dlight},
#     'light-heavy-light'    : {'A' : dlight, 'B' : dheavy, 'C' : dlight},
#     'light-light-heavy'    : {'A' : dlight, 'B' : dlight, 'C' : dheavy},
    'light-medium-medium'  : {'A' : dlight, 'B' : dmoder, 'C' : dmoder},
    'medium-light-medium'  : {'A' : dmoder, 'B' : dlight, 'C' : dmoder},
    'medium-medium-light'  : {'A' : dmoder, 'B' : dmoder, 'C' : dlight},
    'medium-medium-medium' : {'A' : dmoder, 'B' : dmoder, 'C' : dmoder}
}

#     'harmonic-all' : {'A' : uniform_choice([3000, 6000, 48000, 96000]), 'B' : uniform_choice([6000, 12000, 96000, 192000]), 'C' : uniform_int(3000,  500000)},
NAMED_PERIODS = {
    'harmonic-short'       : {'A' : uniform_choice([3000, 6000]), 'B' : uniform_choice([6000, 12000]), 'C' : uniform_int( 3000,  33000)},
    'harmonic-contrast'    : {'A' : uniform_choice([3000, 6000]), 'B' : uniform_choice([96000, 192000]), 'C' : uniform_int(5000, 100000)},
    'harmonic-long'        : {'A' : uniform_choice([48000, 96000]), 'B' : uniform_choice([96000, 192000]), 'C' : uniform_int(50000, 500000)},
}

#     'uni-all'       : {'A' : uniform(0.001, 0.2), 'B' : uniform(0.001, 0.4), 'C' : uniform(0.001, 0.6)},
NAMED_UTILIZATIONS = {
    'uni-light'     : {'A' : uniform(0.001, 0.03), 'B' : uniform(0.001, 0.05), 'C' : uniform(0.001, 0.1)},
    'uni-medium'    : {'A' : uniform( 0.02, 0.1), 'B' : uniform( 0.05, 0.2), 'C' : uniform(  0.1, 0.4)},
    'uni-heavy'     : {'A' : uniform(  0.1, 0.2), 'B' : uniform( 0.2, 0.4), 'C' : uniform(  0.4, 0.6)},
}

#     'uni-all'               : uniform(0.01, 0.5),
NAMED_MEMORY = {
    'uni-light'           : uniform(0.01, 0.1),
    'uni-medium'          : uniform(0.1, 0.25),
    'uni-heavy'           : uniform(0.25, 0.5),
}

NAMED_A_INFLATIONS = {
    'constant'      : uniform(1.5, 1.5),
    'vary-small'    : uniform(1.3, 1.7),
    'vary-large'    : uniform(1.1, 1.9),
}

class Custom:
    pass

PAB = Custom()
PAB.ks = uniform(0.01, 0.05)
PAB.kw = uniform(0.01, 0.02)
PAB.kp = uniform(0.025, 0.75)
PAB.kmin = uniform(0.4, 0.8)

PAC = Custom()
PAC.ks = uniform(0.005, 0.03)
PAC.kw = uniform(0.01, 0.02)
PAC.kp = uniform(0.025, 0.75)
PAC.kmin = uniform(0.4, 0.8)

P = {
    'A': {'A': PAB},
    'B': {'A': PAB},
    'C': {'A': PAC}
}

redfunc = uniform(0, 0.05)